/*	$NetBSD: aica_arm_locore.S,v 1.2 2005/12/11 12:17:06 christos Exp $	*/

/*
 * Copyright (c) 2003 SHIMIZU Ryo <ryo@misakimix.org>
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define AICA_BUSREQ_REG		0x00802808
#define AICA_ARMINTNUM_REG	0x00802d00
#define AICA_ARMINTRST_REG	0x00802d04

	.text
	.globl

	b	exp_reset
	b	exp_undef
	b	exp_swi
	b	exp_pabort
	b	exp_dabort
	b	exp_reserved
	b	exp_irq
/*	b	exp_fiq	*/
exp_fiq:
	ldr	r8, aica_armintnum_reg
	ldr	r8, [r8]
	and	r8, r8, #7
	cmp	r8, #2
	beq	fiq_timer
	cmp	r8, #5
	bne	fiq_done
fiq_busreq:
	/* suspend any G2 DMA */
	ldr	r8, aica_busreq_reg
1:	ldr	r9, [r8]
	and	r9, r9, #0x100
	cmp	r9, #0
	bne	1b
	b	fiq_done

fiq_timer:
	/* XXX: not supported yet */

fiq_done:
	/* clear interrupt status */
	ldr	r8, aica_armintrst_reg

	/* write #1 four times to clear? */
	mov	r9, #1
	str	r9, [r8]
	str	r9, [r8]
	str	r9, [r8]
	str	r9, [r8]

	sub	pc, r14, #4

aica_busreq_reg:
	.long	AICA_BUSREQ_REG
aica_armintnum_reg:
	.long	AICA_ARMINTNUM_REG
aica_armintrst_reg:
	.long	AICA_ARMINTRST_REG

exp_reset:
	mov	sp, #0xe000	/* setup stack */

	mrs	r0, CPSR
#if 0
	orr	r0, r0, #0x80	/* FIQ enable */
#else
	bic	r0, r0, #0x80	/* FIQ enable */
#endif
	bic	r0, r0, #0x40	/* IRQ disable */
	msr	CPSR_all, r0
	bl	aica_main
	/* FALLTHRU */

exp_reserved:
	b	exp_reserved

exp_irq:
	sub	pc, r14, #4

exp_dabort:
	sub	pc, r14, #8

exp_pabort:
	sub	pc, r14, #4

exp_swi:
	mov	pc, r14

exp_undef:
	mov	pc, r14

